%global commit 3b62c8e3269c9d760fc2a4182fc1221dcea86b4a
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           stratum-mining-proxy
Version:        1.5.6
Release:        1%{?dist}
Summary:        Getwork-compatible proxy for Stratum mining pools

Group:          Development/Libraries
License:        MIT
URL:            http://github.com/slush0/%{name}
Source0:        http://github.com/slush0/%{name}/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
Source1:        mining_proxy.service
Patch0:         use_setuptools.patch
Patch1:         midstatec_test_return.patch

BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  systemd

%package -n python-%{name}
Summary:        Getwork-compatible proxy for Stratum mining pools
BuildArch:      noarch
Requires:       python-argparse
Requires:       python-twisted-web >= 12.2.0
Requires:       python-stratum >= 0.2.14
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%package midstatec
Summary:        Midstate C extension for stratum-mining-proxy
Requires:       python-%{name} = %{version}-%{release}

%description
Application providing bridge between old HTTP/getwork protocol and Stratum
mining protocol as described here: http://mining.bitcoin.cz/stratum-mining.

%description -n python-%{name}
Application providing bridge between old HTTP/getwork protocol and Stratum
mining protocol as described here: http://mining.bitcoin.cz/stratum-mining.

%description midstatec
For some really big operations using getwork interface of this proxy, you'll
find useful "midstatec" C extension, which significantly speeds up midstate
calculations (yes, plain python implementation is so slow). For enabling this
extension, just type "make" in midstatec directory. Proxy will auto-detect
compiled extension on next startup.

%prep
%setup -qn %{name}-%{commit}
%patch0 -p1
%patch1 -p1

%build
CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build
make %{?_smp_mflags} -C midstatec

%install
%{__python2} setup.py install --skip-build --root %{buildroot}

# Midstate C
mkdir -p %{buildroot}%{python2_sitearch}/midstatec
install -p -m0644 midstatec/__init__.py %{buildroot}%{python2_sitearch}/midstatec/
install -p -m0755 midstatec/midstatec.py %{buildroot}%{python2_sitearch}/midstatec/
install -p -m0755 midstatec/midstate.so %{buildroot}%{python2_sitearch}/midstatec/

# Systemctl
mkdir -p %{buildroot}%{_unitdir}
install -p -m0644 %{SOURCE1} %{buildroot}%{_unitdir}/mining_proxy.service

%check
midstatec/test

%post
%systemd_post mining_proxy.service

%preun
%systemd_preun mining_proxy.service

%postun
%systemd_postun_with_restart mining_proxy.service

%files -n python-%{name}
%doc README.md
%{python2_sitelib}/mining_libs
%{python2_sitelib}/stratum_mining_proxy*
%{_bindir}/mining_proxy.py
%{_unitdir}/mining_proxy.service

%files midstatec
%{python2_sitearch}/midstatec

%changelog
* Sun Oct 19 2014 Scott K Logan <logans@cottsay.net> - 1.5.6-1
- Update to 1.5.6

* Sun Jan 26 2014 Scott K Logan <logans@cottsay.net> - 1.5.2-1
- Initial package creation
